{:Unit Desc.
@author Neftal -Germn Estvez-
@Web    http://neftali.clubdelphi.com
@cat
}
unit FMain;
{=========================================================================
  Historia de las Versiones
------------------------------------------------------------------------

  XX/XX/XXXX
  * Creacin.
------------------------------------------------------------------------
   ...

=========================================================================

  Errores detectados no corregidos

=========================================================================}


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Contnrs, ComCtrls;

type
  TForm1 = class(TForm)
    pnlSuperior: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    BitBtn1: TBitBtn;
    Panel4: TPanel;
    Shape1: TShape;
    Shape2: TShape;
    TrackBar1: TTrackBar;
    StatusBar1: TStatusBar;
    BitBtn2: TBitBtn;
    cbRotacion: TCheckBox;
    Timer1: TTimer;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure StatusBar1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure cbRotacionClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    imList:TStringList;
    oList:TObJectList;
    _LastIndex:Integer;

    procedure _CreateImages(imList:TStringList);
    procedure ClickImage(Sender: TObject);

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

//: Devuelve una lista de ficheros
procedure FindFiles(StartDir, FileMask: string; recursively: boolean;
                    var FilesList: TStringList);

implementation

{$R *.dfm}

uses
  ShellAPI,
  FileCtrl, jpeg;

{: Devuelve una lista de nombres de fichero encontrados a partir de la carpeta
   inicial StartDir, que cumplen el patrn especificado por FileMask. Mediante
   recursively se indica si se desea hacer la busqueda en los subdirectorios.
  @param    StartDir    Carpeta desde la que empezar a buscar.
  @param    FileMask    Patrn que han de cumplir los ficheros.
  @param    recursively Si hay que continuar la bsuqueda en los subdirectorios.
  @param    FilesList   Lista con los nombres de fichero encontrados.)
}
procedure FindFiles(StartDir, FileMask: string; recursively: boolean; var FilesList: TStringList);
var
  SR: TSearchRec;
  DirList: TStringList;
  IsFound: Boolean;
  i: integer;
begin
  if (StartDir[length(StartDir)] <> '\') then begin
    StartDir := StartDir + '\';
  end;

  // Crear la lista de ficheos en el directorio StartDir (no directorios!)
  IsFound := FindFirst(StartDir + FileMask, faAnyFile - faDirectory, SR) = 0;
  // MIentras encuentre
  while IsFound do  begin
    FilesList.Add(StartDir + SR.Name);
    IsFound := FindNext(SR) = 0;
  end;

  FindClose(SR);

  // Recursivo?
  if (recursively) then begin
    // Build a list of subdirectories
    DirList := TStringList.Create;
    // proteccion
    try
      IsFound := FindFirst(StartDir + '*.*', faAnyFile, SR) = 0;
      while IsFound do
      begin
        if ((SR.Attr and faDirectory) <> 0) and
          (SR.Name[1] <> '.') then
          DirList.Add(StartDir + SR.Name);
        IsFound := FindNext(SR) = 0;
      end;
      FindClose(SR);

      // Scan the list of subdirectories
      for i := 0 to DirList.Count - 1 do
        FindFiles(DirList[i], FileMask, recursively, FilesList);
    finally
      DirList.Free;
    end;
  end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  FDirectorio:string;
begin

  // Limpiar las listas
  oList.Clear;
  imList.Clear;
  Image1.Picture.Assign(nil);

  // Vacio?
  if (FDirectorio = '') then begin
    FDirectorio := ExtractFilePath(Application.ExeName) + 'img';
  end;

  // Si se selecciona un nuevo directorio ...
  if (SelectDirectory('Seleccionar diredctorio...', '', FDirectorio)) then begin
    // cargar las imgenes
    FindFiles(FDirectorio, '*.jpg', True, imList);

    if (imList.Count > 0) then begin
      _CreateImages(imList);
    end;
  end;

  cbRotacion.Enabled := True;
end;

procedure TForm1.ClickImage(Sender: TObject);
begin
  Image1.Picture.Assign(TImage(Sender).Picture);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  imList := TStringList.Create();
  oList := TObjectList.Create();
end;

procedure TForm1._CreateImages(imList: TStringList);
var
  im:TImage;
  i:Integer;
  pnl:TPanel;
begin

  // Para cada imagen
  for i := 0 to (imList.Count - 1) do begin
    // Crear el control imagen
    im := TImage.Create(nil);
    // Asignar propiedades
    im.Parent := ScrollBox1;
    im.Height := ScrollBox1.Height;
    im.Width := im.Height;
    im.Top := 0;
    im.Left := ((im.Width + 15{panel} + 4) * i);
    im.Transparent := true;
    im.Align := alLeft;
    im.Stretch := True;
    im.Proportional := True;

    // Cargar
    im.Picture.LoadFromFile(imList[i]);
    // vebto OnClick
    im.OnClick := ClickImage;
    // Aadirla a la lista de objetos
    oList.Add(im);

    // Separados
    pnl := TPanel.Create(nil);
    pnl.Parent := ScrollBox1;
    pnl.Left := im.Left + 5;
    pnl.Width := 15;
    pnl.Height := im.Height;
    pnl.Align := alLeft;
    pnl.Color := clBlack;
    // Aadirlo a la lista de objetos
    oList.Add(pnl);

  end;

  // Cargar la primera
  Image1.Picture.Assign(TImage(Olist.Items[0]).Picture);


end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(OList);
  FreeAndNil(imList);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var
  i:Integer;
  obj:TComponent;
begin
  pnlSuperior.Height := (40 * TrackBar1.Position);

  // reajustar tamaos...
  for i := 0 to (oList.Count - 1) do begin
    obj := Tcomponent(OList.Items[i]);
    if (obj is TImage) then begin
      TImage(obj).Width := TImage(obj).Height;
    end;
  end;


end;

procedure TForm1.StatusBar1Click(Sender: TObject);
begin
    ShellExecute(Handle,
             'open',
             'http://neftali.clubdelphi.com/',
             nil,
             nil,
             SW_SHOW);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  Self.Close;
end;

procedure TForm1.cbRotacionClick(Sender: TObject);
begin
  Timer1.Enabled := cbRotacion.Checked;
  if not (Timer1.Enabled) then begin
    _LastIndex := -1;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  obj:TComponent;
begin

  if (_LastIndex = -1) then begin
    _LastIndex := 0;
  end;

  if (_LastIndex >= oList.Count) then begin
    _LastIndex := 0;
  end;

  obj := Tcomponent(oList.Items[_LastIndex]);
  if (obj is TImage) then begin
    Image1.Picture.Assign(TImage(oList.Items[_LastIndex]).Picture);
    _LastIndex := _LastIndex + 2;
  end;

end;

end.


